//Michael Good, 12/7/2011
//Veronica Hull, 12/7/2011
//Renee Sundrud, CPS 162
//
// VERSION: M5f:V3f:S0
//
//

#ifndef BOARDPOSITION_H
#define BOARDPOSITION_H
#include <iostream>
#include <vector>

using namespace std;

class BoardPosition
{     
      public:
             struct checker
            {
                   bool king;   //whether the piece is a king or not
                   bool exists; //whether the piece has been captured or not
                   int x;       //x location of checker on board
                   int y;       //y location of checker on board
                   int side;    //1 for player, -1 for computer
                                //Note: side is also used for direction
            };
            
            //checkers! :D
            checker mine[12];
            checker AI[12];
            
            // ------- CONSTRUCTOR -------
            //constructor; initializes all pieces to beginning of game
            BoardPosition();
            
            // ------ AI FUNCTIONS -------
            //finds the best move for the computer to make, returns best move
            //@param level:  what level is being played at (must be at least 1)
            //@param (rest): all other parameters are used solely for recursive
            BoardPosition BoardPosition::bestMove
                          (int level, bool player = false, bool first = true);
            // returns the point value for a given side. Used to calculate best
            //move, as well as find out who won or lost.
            //@param side: -1 for player, 1 for AI
            double pointValue(int side);
            
            // ------- OPERATORS --------
            //compares two boards to see if they have the same position
            bool operator == (BoardPosition compare);
            //compares just one side of checkers (useful for validating jumps)
            bool operator == (checker compare[12]);
            //sets one board position to be a copy of the other board position
            void operator = (BoardPosition *toSet);
            
            // ---- OTHER FUNCTIONS -----
            // gets moves for all checkers on a given side by calling findMoves
            //for each checker
            //@param who: which side we are getting moves for
            //            set who to be "ai" or "me"
            vector<BoardPosition> stackMoves(string who);   
            // gets moves for a single checker. Useful for finding moves for one
            //checker; also called by stackMoves for each checker
            //@param *piece: one checker.
            //@param *jumps: if there are jumps or not (optional)
            vector<BoardPosition> findMoves(checker *piece, int *jumps = false);            
            //checks if a tile is occupied
            //@param x, y: coordinates
            int occupied (int x, int y);            
            //returns the checker on the given tile
            //@param x, y: coordinates
            checker *getChecker (int x, int y);          
            //returns how many pieces a side has
            //@param who: which side we are getting moves for
            //            set who to be "ai" or "me"
            int pieceCount(string who); 
            
      private:           
              //checks to see if there are any jumps available
              bool isJump(checker *piece);
              
              //finds all jumps available to a piece
              bool getJumps(checker *piece, vector<BoardPosition> &moves);
};

#endif
